/*
**  Header-cracking and address re-writing routines, with sincere
**  apologies to Upas and Sendmail.
*/
#include "gate.h"
#include <netdb.h>
#ifdef	RCSID
static char RCS[] =
	"$Header: /nfs/papaya/u2/rsalz/src/newsgate/src/RCS/hdr.c,v 1.15 91/03/15 16:39:42 rsalz Exp $";
#endif	/* RCSID */


#ifndef	DO_FIX_ADDRESS
#define DO_FIX_ADDRESS
#endif	/* DO_FIX_ADDRESS */
#define dprintf(string, buff)	/* NULL */

STATIC char *
StripSpaces(s)
    register char      *s;
{
    register char      *cp;

    if (s == NULL || *s == '\0')
       return s;

    /* Skip leading spaces. */
    while (*s && isspace(*s))
       s++;

    /* zap trailing spaces */
    for (cp = &s[strlen(s) - 1]; cp > s && isspace(*cp); )
       cp--;
    cp[1] = '\0';
    return s;
}


/*
**  Local user?
*/
STATIC int
Local(p)
    register char	*p;
{
    for ( ; *p; p++)
	if (NETCHR(*p))
	    break;
    return *p == '\0';
}



/*
**  Handle route-addresses:
**	@cruft:joe@site --> joe@site
*/
STATIC void
RouteAddr(p)
    register char	*p;
{
    register char	*q;
    register char	*r;

    for (r = p; *p == '@'; p = q)
	if ((q = IDX(p, ':')) && IDX(q, '@'))
	    *q++ = '\0';
	else
	    break;
    if (p > r)
	/* Avoid overlaping strcpy() call. */
	while (*r++ = *p++)
	    ;
}


/*
**  Handle the '%' syntax:
**	joe%site.EDU@gateway.DOMAIN -> joe@site.EDU
*/
STATIC void
Percent(p)
    register char	*p;
{
    register char	*q;
    register char	*r;
    register char	**dp;

    while ((r = IDX(p, '%')) && (q = IDX(r, '@'))) {
	*RDX(p, '@') = '\0';
	*RDX(p, '%') = '@';
		break;
    }
}


/*
**  Handle hybrid "!" and "@" addresses:
**	a!site!joe@site --> joe@site
**	a!site!joe --> joe@site.UUCP
**	a!site.EDU!joe --> joe@site.EDU
*/
STATIC void
Hybrid(p)
    register char	*p;
{
    register char	*q;
    register char	*user;
    char		buff[SM_SIZE];

    if (user = RDX(p, '!')) {
	*user++ = '\0';
	if (q = IDX(user, '@'))
	    *q = '\0';
	q = (q = RDX(p, '!')) ? q + 1 : p;
	Sprintf(buff, "%s@%s", user, q);
	if (IDX(q, '.') == NULL)
	    Strcat(buff, ".UUCP");
	Strcpy(p, buff);
    }
}

/*
**  General address canonicalizer.
*/
STATIC char *
FixAddress(p)
    register char	*p;
{
    static char		buff[1024];
    char		host[128];

    if (Local(p)) {
	if (gethostname(host, sizeof host) < 0) {
	    Fprintf(stderr, "from:  Can't get my hostname, %s.\n",
		    strerror(errno));
	    exit(EX_TEMPFAIL);
	}
	Sprintf(buff, "%s@%s", p, host);
    }
    else {
	Strcpy(buff, p);
	RouteAddr(buff);
	dprintf("RouteAddr returns %s\n", buff);
	Hybrid(buff);
	dprintf("   Hybrid returns %s\n", buff);
	Percent(buff);
	dprintf("  Percent returns %s\n", buff);
    }
    return buff;
}


/*
**  Count the number of '@' in the string.
*/
STATIC int
AtCount(s)
    register char	*s;
{
    register int	n;

    for (n = 0; *s; s++)
	if (*s == '@')
	    n++;
    return n;
}


/*
**  Canonicalize the "From:" line into the form
**	From: local-part@domain (full-name)
** RFC822 doesn't require the comment to be at the end of the string
** like that.
*/
char *FixFrom(hp)
    register char 		*hp;
{
    register char		*p;
    register struct hostent	*host;
    char			address[LG_SIZE];
    char			fullname[LG_SIZE];
    char			scratch[sizeof address];

    /* We should handle "Full-Name:" too, but it doesn't get read by the
     * news header reader. */
    (void)CrackFrom(address, fullname, hp);
#ifdef	DO_ADDRESS_CLEANUP
    Strcpy(address, FixAddress(address));
#endif	/* DO_ADDRESS_CLEANUP */

    if (AtCount(address) != 1)
	p = NULL;
    else {
	p = IDX(address, '@');
	*p++ = '\0';

#ifdef	DO_ADDRESS_CLEANUP
	/* If we can find the host's official name use that. */
	if (host = gethostbyname(p))
	    p = host->h_name;
#endif	/* DO_ADDRESS_CLEANUP */

	/* We know have the canonical hostname; glue back together. */
	Sprintf(scratch, "%s@%s", address, p);
	Strncpy(address, scratch, sizeof address);
	address[sizeof address - 1] = '\0';
	p = IDX(address, '@');
	*p++ = '\0';
    }

    /* Policy decision; what to put in the path? */

    /* Restore the @ if we took it out. */
    if (p)
	*--p = '@';

    if (fullname[0]) {
	p = address + strlen(address);
	*p++ = ' ';
	*p++ = '(';
	p += APPEND(p, fullname);
	*p++ = ')';
	*p++ = '\0';
    }

    /* Stick the canonicalized From: back in. */
    Strcpy(hp, address);
}


main()
{
    char	buff[256];
    int		i;

    if (i = isatty(0))
	(void)printf("Enter addresses:\n");
    for ( ; ; ) {
	if (i)
	    (void)printf(">  ");
	if (gets(buff) == NULL || buff[0] == '\0')
	    break;
	if (buff[0] != '#')
	    (void)printf("%s\n", FixFrom(buff));
    }

    exit(0);
}


/*
**  Crack an RFC822 from header field into address and fullname.  We do
**  this to make sure we write things out in official form.  "Be liberal
**  in what you accept, conservative in what you generate."  Anyhow, we
**  read things into three buffers, one for all <...> text, one for all
**  (...) text, and a third for stuff not in either.  Either the first or
**  third buffer will be the real address, depending on whether there is
**  anything in buffer two or not.
*/
int
CrackFrom(addr, name, p)
    char		*addr;
    char		*name;
    char		*p;
{
    register char	*ap;
    register char	*cp;
    register int	flag;
    register int	comment;
    register int	address;
    register int	addrfound;
    char		*comm;
    char		commbuf[LG_SIZE];
    char		addrbuf[LG_SIZE];

    /* Just to make sure. */
    *name = '\0';
    *addr = '\0';

    if (p == NULL)
	return FALSE;

    /* Eat leading white space. */
    while (*p && isspace(*p))
	p++;

    /* Set defaults.  Start with an allocated copy of a comment string. */
    comm = COPY("");
    ap = addrbuf;
    comment = 0;
    addrfound = 0;
    address = 0;
    for (flag = 0; *p; p++) {
	switch (*p) {
	case '"':
	    if (flag) {
		flag--;
		goto EndComment;
	    }
	    flag++;
	    /* FALLTHROUGH */
	case '(':
	    if (comment == 0) {
		cp = commbuf;
		*cp = '\0';
	    }
	    comment++;
	    break;
	case ')':
    EndComment:
	    if (comment > 0 && --comment == 0) {
		if (*p != ')' && *p != '"')
		    *cp++ = *p;		/* Copy the comment-closer */
		*cp = '\0';
		if (*comm == '\0') {
		    free(comm);
		    comm = COPY(&commbuf[1]);
		}
		else {
		    cp = NEW(char, strlen(comm) + 2 + strlen(&commbuf[1]) + 1);
		    (void)sprintf(cp, "%s, %s", comm, &commbuf[1]);
		    free(comm);
		    comm = cp;
		}
		cp = NULL;
		continue;
	    }
	    break;
	case '<':
	    if (address) {
		free(comm);
		return FALSE;	/* AWK! Abort! */
	    }
	    if (!comment) {
		address++;
		*ap = '\0';
		ap = addr;
	    }
	    break;
	case '>':
	    if (!comment && address) {
		address--;
		addrfound++;
		*ap = '\0';
		ap = &addrbuf[strlen(addrbuf)];
		p++;	/* skip the `>' */
	    }
	    break;
	}

	if (comment)
	    *cp++ = *p;
	else if (!address || *p != '<')
	    *ap++ = *p;
	if (*p == '\0')
	    break;
    }

    *ap++ = '\0';

    if (addrfound) {
	Strcpy(name, StripSpaces(addrbuf));
	Strcpy(addr, strcpy(commbuf, StripSpaces(addr)));
    }
    else {
	(void)strcpy(addr, StripSpaces(addrbuf));
	*name = '\0';
    }
    /* Just to be sure that we got the full name, we'll take all of
     * the comments. */
    if (*comm) {
	if (*name)
	    Strcat(name, ", ");
	Strcat(name, comm);
    }
    free(comm);
    return TRUE;
}


/*
**  Allocate memory.
*/
align_t
MyAlloc(i)
    int			i;
{
    align_t		p;

    if ((p = (align_t)malloc((unsigned int)i)) == NULL) {
	Fprintf(stderr, "from:  Could not allocate %d bytes: %s\n",
		i, strerror(errno));
	exit(EX_OSERR);
    }
    return p;
}


#ifndef	HAVE_STRERROR
/*
**  Return a printable representation of errno.
*/
char *
strerror(x)
    int			x;
{
    static char		buff[20];

    if (x >= 0 && x < sys_nerr)
	return sys_errlist[x];
    Sprintf(buff, "Error code %d", x);
    return buff;
}
#endif	/* HAVE_STRERROR */

