/*
 * reply.c --- quich hach to get return addresses.
 *
 *   Usually used as:
 *	sendmail `reply incoming` < recorded-message
 *
 *   Gene Spafford, January 1989
 */

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#define index strchr

extern char    *index (), *malloc();
int             finish = 0;

#define MAXLEN 2048

main (argc, argv)
int             argc;
char          **argv;
{
    FILE           *input;
    char            inpline[MAXLEN],
                   *cp,
                   *sp;
    static void     getcline (),
                    quoteput ();
    char           *uFrom = NULL,
                   *replyto = NULL,
		   *returnpath = NULL,
                   *from = NULL;

    if (argc > 1)
	input = fopen (argv[1], "r");
    else
	input = stdin;

    if (input == NULL)
    {
	fputs ("No input file.\n", stderr);
	exit (2);
    }

    while (!finish)
    {
	getcline (input, inpline);
	if (finish)
	    break;

	sp = cp = strpbrk (inpline, " \t");
	if (cp == NULL)
	    sp = cp = index(inpline, ':')+1;
	if (cp == NULL)
	    continue;
	*cp = 0; sp++;
	while (cp-- != inpline)
	{
	    if (isupper (*cp))
		*cp = tolower (*cp);
	}

	sp += strspn (sp, " \t");
	cp = malloc(strlen(sp)+1);
	strcpy(cp, sp);

	if (strcmp (inpline, "from:") == 0)
	    from = cp;
	else if (strcmp (inpline, "from") == 0)
	    uFrom = cp;
	else if (strcmp (inpline, "reply-to:") == 0)
	    replyto = cp;
	else if (strcmp (inpline, "return-path:") == 0)
	    returnpath = cp;
	else
	    free(cp);
    }

    if (replyto != NULL)
	puts (replyto);
    else if (from != NULL)
	puts (from);
    else if (returnpath != NULL)
	puts (returnpath);
    else if (uFrom != NULL)
	puts (uFrom);
    else
	exit (3);

    exit (0);
}


static void 
getcline (fd, fline)
FILE           *fd;
char           *fline;
{
    int             c;
    char           *xp,
                    tempb[MAXLEN];

    fgets (fline, MAXLEN, fd);
    xp = index (fline, '\n');
    *xp = 0;

    if (!*fline)
    {
	finish = 1;
	return;
    }


    c = getc (fd);
    ungetc (c, fd);
    if (c == ' ' || c == '\t')
    {
	fgets (tempb, MAXLEN, fd);
	*xp = ' ';
	c = strspn(tempb, " \t");
	strcat (xp, tempb+c);
	xp = index (fline, '\n');
	*xp = 0;
    }
}

static void 
quoteput (str)
char           *str;
{
    while (*str)
    {
	if (*str == '"')
	    putchar('\\');
        putchar (*str);
	str++;
    }
    putchar ('\n');
}


